#include <unistd.h>

#include "io.h"
#include "keys.h"

int getkey()
{
	static int buffer = -1;
	int ch;
	
	if(buffer >= 0)
	{
		ch = buffer;
		buffer = -1;
		return ch;
	}
	
	ch = getch();
	
	if(ch == kbhome
	|| ch == kblt
	|| ch == kbend
	|| ch == kbdel
	|| ch == kbrt
	|| ch == kbbell
	|| ch == kbtab
	|| ch == kbdn
	|| ch == kbup
	|| ch == kbpgup
	|| ch == kbpgdn)return ch;
	
	if(ch == 8 || ch == 127)return kbback;
	if(ch == 10 || ch == 13)return kbenter;
	
	if(ch == kbesc)
	{
		unsigned n = 0;
		int a;

    	for(a=0; a<30; ++a) { if(kbhit())break; usleep(10000); }
    	if(!kbhit())return ch;
    	
		ch = getch();
		if(ch != '[') { buffer = ch; return kbesc; }
		for(;;)
		{
        	for(a=0; a<30; ++a) { if(kbhit())break; usleep(10000); }
        	if(!kbhit())return ch;
        	
			ch = getch();
			if(ch < '0' || ch > '9')break;
			n = n*10 + ch-'0';
		}
		if(ch == 'A')return kbup;
		if(ch == 'B')return kbdn;
		if(ch == 'C')return kbrt;
		if(ch == 'D')return kblt;
		if(ch == '~')
			switch(n)
			{
				case 1: return kbhome;
				case 3: return kbdel;
				case 4: return kbend;
				case 5: return kbpgup;
				case 6: return kbpgdn;
			}
		return kbesc;
	}
	return ch;
}
